\section{Methodology}

The main software tools used in this project are Python, ROS2, Gazebo simulator
and RViz. The project is divided into two main parts: the simulation of the
environment with mobile robots and the implementation of the centralized
controller. The simulation is done in Gazebo and RViz, while the controller is
implemented in Python and ROS2.

The flow of the one robot navigation is described in the
algorithm~\ref{alg:navigation-one-robot}. The algorithm is implemented in the
\begin{algorithm}
    \caption{One robot navigation algorithm}%
    \label{alg:navigation-one-robot}
    \begin{algorithmic}[1]
        \item Receive message for robot mission.
        \item Ask the navigation stack for the path to the goal.
        \item Divide the path into smaller equal segments.
        \item Navigate robot segment by segment.
        \item Stop the robot if its next segment is occupied.
        \item Repeat from step 4 until the goal is reached.
    \end{algorithmic}
\end{algorithm}
\texttt{controller} node. The node subscribes to the \texttt{mmrs/mission}
topic and sends the \texttt{navigate} action to the corresponding navigator.
The navigators are implemented in the \texttt{navigator} node. All software
nodes communicate with each other using custom created ROS2 messages, actions
and services. The project is structured as two ROS2 packages:
\texttt{mmrs\_controller} and \texttt{mmrs\_msgs}. The first one contains the
controller and the navigators, while the second one contains the custom
messages, actions and services.
